function createLogger() {
	var outputCounter = 1;

	return function(output) {
		console.log("(" + outputCounter++ + ") " + output);
	};
}

var manualLogger = createLogger();

manualLogger("Something happened!");
manualLogger("Something else happened!");

var logger = (function() {
	var outputCounter = 1;

	return {
		log: function(output) {
			console.log("(" + outputCounter++ + ") " + output);
		}
	};
}());

logger.log("Something happened again!");
logger.log("Something keeps happening!");
logger.log("Oh well... third line.");



// syntax can vary - both of these are commonly used

(function() { console.log("test") })();
(function() { console.log("test") }());

// this doesn't work
//function() { console.log("test") }();

// but these do, and you see them occasionally
~function() { console.log("test") }();
0,function() { console.log("test") }();
true && function() { console.log("test") }();
